UNIT mTZeitgeber;

interface

uses        dialogs, mSuM,mUhr,mTEreignisbearbeiter;
// Uses-Klausel ggf. anpassen

type
   TZeitgeber = CLASS(TEreignisbearbeiter)

     // Attribute
     private
        hatUhr : Uhr;
        zAktiv : Wahrheitswert;
        letzterZeitpunkt : Zahl;
        zZeittakt : Zahl;
     public
        meineZeitgeberAktion : procedure (sender : TObject ) of Object;

     // Methoden
     private
        function jetzt : Zahl;
     public
        constructor init(pZeittakt:Zahl;pMaus:Maus);
        procedure bearbeiteMeinenLeerlauf(sender : TObject); override;
        procedure setzeZeittakt(pDauer:GanzeZahl);
        procedure start;
        procedure stopp;

   end;

implementation

//+---------------------------------------------------------------------
//|         TZeitgeber: Methodendefinition 
//+---------------------------------------------------------------------

//-------- jetzt (private) ---------------------------------------------
function TZeitgeber.jetzt : Zahl;
begin
  result := (((hatUhr.stunde * 60 + hatUhr.minute)*60 + hatUhr.sekunde)*1000)+
             hatUhr.millisekunde
end;

//-------- init (public) -----------------------------------------------
constructor TZeitgeber.init(pZeittakt:Zahl;pMaus:Maus);
begin
   inherited init(pMaus);
   zZeittakt := pZeittakt;
   zAktiv := False;
   letzterZeitpunkt := jetzt;

end;

//-------- bearbeiteMeinenLeerlauf (public) ----------------------------
procedure TZeitgeber.bearbeiteMeinenLeerlauf(sender : TObject);
begin
   if zAktiv then begin
      if jetzt > letzterZeitpunkt + zZeittakt then
      begin
        letzterZeitpunkt := jetzt;
        meineZeitgeberAktion(sender)
      end;
   end;
   if naechsterEreignisbearbeiter <> nil
      then naechsterEreignisbearbeiter.bearbeiteMeinenLeerlauf(sender)
end;

//-------- setzeZeittakt (public) --------------------------------------
procedure TZeitgeber.setzeZeittakt(pDauer:GanzeZahl);
begin
  zZeittakt := pDauer;
  letzterZeitpunkt := jetzt;
end;

//-------- start (public) ----------------------------------------------
procedure TZeitgeber.start;
begin
  zAktiv := Wahr;
  letzterZeitpunkt := jetzt;
end;

//-------- stopp (public) ----------------------------------------------
procedure TZeitgeber.stopp;
begin
  zAktiv := Falsch
end;

end.
