UNIT mTWaggonEreignisAnwendung;

interface

uses                 mSum,mTEreignisVerteilerAnwendung, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive, 
         mTRechteckKnopf,mTKnopf,mTZeitgeber;
// Uses-Klausel ggf. anpassen

type
   TWaggonEreignisAnwendung = CLASS(TEreignisVerteilerAnwendung)

     // Attribute
     private
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfEnde : TRechteckKnopf;
        KnopfFahre : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        hatZeitgeber : TZeitgeber;

     //Objektbeziehungen:
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTLokomotive : TLokomotive;
        // hatTZeitgeber : TZeitgeber;

     // Methoden
     public
        constructor init; override;
        procedure hatZeitgeberAktion(sender : TObject);
        procedure KnopfEndeClick(sender : TObject);
        procedure KnopfFahreClick(sender : TObject);
        procedure KnopfNeuerGueterwagenClick(sender : TObject);
        procedure KnopfNeuerPersonenWagenClick(sender : TObject);
        procedure KnopfStoppClick(sender : TObject);
        procedure TastaturAktion(sender : TObject ; pZeichen:Zeichen);
        procedure WaggonClick(sender : TObject);
        procedure WaggonDoppelKlick(sender : TObject);
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonEreignisAnwendung.init;
begin
  inherited init;
  meineLokomotive   := TLokomotive.init(500,250,90,dieMaus);

  ErsterKnopf       := TKnopf.init(0,0,0,'ersterKnopf',dieMaus);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);

  hatZeitgeber := TZeitgeber.init(1,dieMaus);

  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfFahre);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfStopp);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfEnde);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfNeuerGueterwagen);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfNeuerPersonenwagen);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatZeitgeber);
  ErsterKnopf.haengeEreignisbearbeiterAn(meineLokomotive);

  meineLokomotive.meineClickAktion := WaggonClick;
  meineLokomotive.meineDoppelKlickAktion := WaggonDoppelKlick;

  ErsterKnopf.meineTastaturDruckAktion := TastaturAktion;
  Knopffahre.meineClickAktion := KnopfFahreClick;
  KnopfStopp.meineClickAktion := KnopfStoppClick;
  KnopfEnde.meineClickAktion := KnopfEndeClick;
  KnopfNeuerGueterwagen.meineClickAktion := KnopfNeuerGueterwagenClick;
  KnopfNeuerPersonenwagen.meineClickAktion := KnopfNeuerPersonenwagenClick;
  hatZeitgeber.meineZeitgeberAktion := hatZeitgeberAktion;

end;

  // Aktionsteil

//-------- hatZeitgeberAktion (public) ---------------------------------
procedure TWaggonEreignisAnwendung.hatZeitgeberAktion(sender : TObject);
begin
   meineLokomotive.bewegeUm(1.5)
end;

//-------- KnopfEndeClick (public) -------------------------------------
procedure TWaggonEreignisAnwendung.KnopfEndeClick(sender : TObject);
begin
   self.beenden
end;

//-------- KnopfFahreClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfFahreClick(sender : TObject);
begin
   hatZeitgeber.start
end;

//-------- KnopfNeuerGueterwagenClick (public) -------------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerGueterwagenClick(sender : TObject);
begin
   naechsterGueterwagen := TGueterwagen.init(20,300,112,dieMaus);
   naechsterGueterwagen.meineClickAktion := WaggonClick;
   naechsterGueterwagen.meineDoppelKlickAktion := WaggonDoppelKlick;
   meineLokomotive.koppleAn(naechsterGueterwagen);
   ersterKnopf.haengeEreignisbearbeiterAn(naechsterGueterwagen);
end;

//-------- KnopfNeuerPersonenWagenClick (public) -----------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerPersonenWagenClick(sender : TObject);
begin
   naechsterPersonenwagen := TPersonenwagen.init(20,300,92,dieMaus);
   naechsterPersonenwagen.meineClickAktion := WaggonClick;
   naechsterPersonenwagen.meineDoppelKlickAktion := WaggonDoppelKlick;
   meineLokomotive.koppleAn(naechsterPersonenwagen);
   ersterKnopf.haengeEreignisbearbeiterAn(naechsterPersonenwagen);
end;

//-------- KnopfStoppClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfStoppClick(sender : TObject);
begin
  hatZeitgeber.stopp
end;

//-------- TastaturAktion (public) -------------------------------------
procedure TWaggonEreignisAnwendung.TastaturAktion(sender : TObject ; pZeichen:Zeichen);
begin
   if pZeichen = '+' then hatZeitgeber.setzeZeittakt(0)
   else if pZeichen = '-' then hatZeitgeber.setzeZeittakt(50)
   else if pZeichen = 's' then hatZeitgeber.stopp
   else if pZeichen = 'f' then hatZeitgeber.start
   else if pZeichen = 'g' then KnopfneuerGueterwagenClick(sender)
   else if pZeichen = 'p' then KnopfneuerPersonenwagenClick(sender)
   else if pZeichen = 'e' then beenden
end;

//-------- WaggonClick (public) ----------------------------------------
procedure TWaggonEreignisAnwendung.WaggonClick(sender : TObject);
begin
   TWaggon(sender).zeichne;
   TWaggon(sender).hatStift.setzeFarbe(rot);
   TWaggon(sender).zeichne
end;

//-------- WaggonDoppelKlick (public) ----------------------------------
procedure TWaggonEreignisAnwendung.WaggonDoppelKlick(sender : TObject);
begin
   TWaggon(sender).zeichne;
   TWaggon(sender).hatStift.setzeFarbe(schwarz);
   TWaggon(sender).zeichne
end;

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonEreignisAnwendung.gibfrei;
begin
//  meineLokomotive.gibFrei;
  inherited gibFrei
end;

end.
