UNIT mTWaggonEreignisAnwendung;

interface

uses        mSum,mTEreignisAnwendung,
            mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive,
            mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TWaggonEreignisAnwendung = CLASS(TEreignisAnwendung)

     // Attribute
     private
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfEnde : TRechteckKnopf;
        KnopfFahre : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        Fahrzustand : Wahrheitswert;

     //Objektbeziehungen:
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTLokomotive : TLokomotive;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf; override;
        procedure bearbeiteMausClick; override;
        procedure bearbeiteMausDoppelklick; override;
        procedure bearbeiteTastaturDruck(pZeichen:Zeichen); override;
        procedure KnopfEndeClick;
        procedure KnopfFahreClick;
        procedure KnopfNeuerGueterwagenClick;
        procedure KnopfNeuerPersonenWagenClick;
        procedure KnopfStoppClick;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonEreignisAnwendung.init;
begin
  inherited init;
  meineLokomotive   := TLokomotive.init(500,250,90);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);

  Knopffahre.meineClickAktion := KnopfFahreClick;
  KnopfStopp.meineClickAktion := KnopfStoppClick;
  KnopfEnde.meineClickAktion := KnopfEndeClick;
  KnopfNeuerGueterwagen.meineClickAktion := KnopfNeuerGueterwagenClick;
  KnopfNeuerPersonenwagen.meineClickAktion := KnopfNeuerPersonenwagenClick;
  Fahrzustand := false;
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteLeerlauf;
begin
    if fahrzustand then meineLokomotive.bewegeUm(0.5)
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausClick;
begin
    KnopfNeuerGueterwagen.bearbeiteMeinenMausClick;
    KnopfNeuerPersonenwagen.bearbeiteMeinenMausClick;
    KnopfFahre.bearbeiteMeinenMausClick;
    KnopfStopp.bearbeiteMeinenMausClick;
    KnopfEnde.bearbeiteMeinenMausClick;
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausDoppelklick;
begin
  //Hier Code einfgen.
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TWaggonEreignisAnwendung.bearbeiteTastaturDruck(pZeichen:Zeichen);
begin
  //Hier Code einfgen.
end;

//-------- KnopfEndeClick (public) -------------------------------------
procedure TWaggonEreignisAnwendung.KnopfEndeClick;
begin
   self.beenden
end;

//-------- KnopfFahreClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfFahreClick;
begin
   fahrzustand := True
end;

//-------- KnopfNeuerGueterwagenClick (public) -------------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerGueterwagenClick;
begin
   naechsterGueterwagen := TGueterwagen.init(20,300,112);
   meineLokomotive.koppleAn(naechsterGueterwagen)
end;

//-------- KnopfNeuerPersonenWagenClick (public) -----------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerPersonenWagenClick;
begin
   naechsterPersonenwagen := TPersonenwagen.init(20,300,92);
   meineLokomotive.koppleAn(naechsterPersonenwagen)
end;

//-------- KnopfStoppClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfStoppClick;
begin
  fahrzustand := false
end;

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonEreignisAnwendung.gibfrei;
begin
  meineLokomotive.gibFrei;
  KnopfFahre.gibFrei;
  KnopfStopp.gibFrei;
  KnopfEnde.gibFrei;
  KnopfNeuerPersonenwagen.gibFrei;
  KnopfNeuerGueterwagen.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;  

end.
