UNIT mTWaggonEreignisAnwendung;

interface

uses              mSum,mTEreignisVerteilerAnwendung, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive, 
         mTRechteckKnopf,mTKnopf,mTZeitgeber;
// Uses-Klausel ggf. anpassen

type
   TWaggonEreignisAnwendung = CLASS(TEreignisVerteilerAnwendung)

     // Attribute
     private
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfEnde : TRechteckKnopf;
        KnopfFahre : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        hatZeitgeber : TZeitgeber;

     //Objektbeziehungen:
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTLokomotive : TLokomotive;
        // hatTZeitgeber : TZeitgeber;

     // Methoden
     public
        constructor init; override;
        procedure hatZeitgeberAktion;
        procedure KnopfEndeClick;
        procedure KnopfFahreClick;
        procedure KnopfNeuerGueterwagenClick;
        procedure KnopfNeuerPersonenWagenClick;
        procedure KnopfStoppClick;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonEreignisAnwendung.init;
begin
  inherited init;
  meineLokomotive   := TLokomotive.init(500,250,90);

  ErsterKnopf       := TKnopf.init(0,0,0,'ersterKnopf',dieMaus);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);

  hatZeitgeber := TZeitgeber.init(1,dieMaus);

  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfFahre);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfStopp);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfEnde);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfNeuerGueterwagen);
  ErsterKnopf.haengeEreignisBearbeiterAn(KnopfNeuerPersonenwagen);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatZeitgeber);


  Knopffahre.meineClickAktion := KnopfFahreClick;
  KnopfStopp.meineClickAktion := KnopfStoppClick;
  KnopfEnde.meineClickAktion := KnopfEndeClick;
  KnopfNeuerGueterwagen.meineClickAktion := KnopfNeuerGueterwagenClick;
  KnopfNeuerPersonenwagen.meineClickAktion := KnopfNeuerPersonenwagenClick;
  hatZeitgeber.meineZeitgeberAktion := hatZeitgeberAktion;

end;

  // Aktionsteil

//-------- hatZeitgeberAktion (public) ---------------------------------
procedure TWaggonEreignisAnwendung.hatZeitgeberAktion;
begin
   meineLokomotive.bewegeUm(0.5)
end;

//-------- KnopfEndeClick (public) -------------------------------------
procedure TWaggonEreignisAnwendung.KnopfEndeClick;
begin
   self.beenden
end;

//-------- KnopfFahreClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfFahreClick;
begin
   hatZeitgeber.start
end;

//-------- KnopfNeuerGueterwagenClick (public) -------------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerGueterwagenClick;
begin
   naechsterGueterwagen := TGueterwagen.init(20,300,112);
   meineLokomotive.koppleAn(naechsterGueterwagen)
end;

//-------- KnopfNeuerPersonenWagenClick (public) -----------------------
procedure TWaggonEreignisAnwendung.KnopfNeuerPersonenWagenClick;
begin
   naechsterPersonenwagen := TPersonenwagen.init(20,300,92);
   meineLokomotive.koppleAn(naechsterPersonenwagen)
end;

//-------- KnopfStoppClick (public) ------------------------------------
procedure TWaggonEreignisAnwendung.KnopfStoppClick;
begin
  hatZeitgeber.stopp
end;

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonEreignisAnwendung.gibfrei;
begin
  meineLokomotive.gibFrei;
  inherited gibFrei
end;

end.
