UNIT mTAnwendung;

interface

uses      mSum, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive,
         mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        Fahrzustand : Wahrheitswert;
        naechsterGueterwagen : TGueterwagen;
        KnopfEnde : TRechteckKnopf;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfFahre : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;

     //Objektbeziehungen:
        // hatMaus : Maus;
        // hatBildschirm : Bildschirm;
        // hatTLokomotive : TLokomotive;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibfrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm     := Bildschirm.init;
  dieMaus           := Maus.init;
  meineLokomotive   := TLokomotive.init(500,250,90);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);
  Fahrzustand := false;
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  repeat
    if KnopfNeuerGueterwagen.angeklickt then begin
       naechsterGueterwagen := TGueterwagen.init(20,300,112);
       meineLokomotive.koppleAn(naechsterGueterwagen)
    end;
    if KnopfNeuerPersonenwagen.angeklickt then begin
       naechsterPersonenwagen := TPersonenwagen.init(20,300,92);
       meineLokomotive.koppleAn(naechsterPersonenwagen)
    end;
    if KnopfFahre.angeklickt then begin
       fahrzustand := True
    end;
    if KnopfStopp.angeklickt then begin
       fahrzustand := False
    end;
    if fahrzustand then meineLokomotive.bewegeUm(0.5)
  until KnopfEnde.angeklickt;
end;

  // Aufrumen

//-------- gibfrei (public) --------------------------------------------
destructor TAnwendung.gibfrei;
begin
  meineLokomotive.gibFrei;
  KnopfFahre.gibFrei;
  KnopfStopp.gibFrei;
  KnopfEnde.gibFrei;
  KnopfNeuerPersonenwagen.gibFrei;
  KnopfNeuerGueterwagen.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;  

end.
