UNIT mTWaggonAnwendung;

interface

uses       mSum, mTAnwendung,mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive, 
         mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TWaggonAnwendung = CLASS(TAnwendung)

     // Attribute
     private
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfEnde : TRechteckKnopf;
        KnopfFahre : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        Fahrzustand : Wahrheitswert;

     //Objektbeziehungen:
        // hatTLokomotive : TLokomotive;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;

     // Methoden
     public
        constructor init; override;
        procedure run; override;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonAnwendung.init;
begin
  inherited init;
  meineLokomotive   := TLokomotive.init(500,250,90);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);
  Fahrzustand := false;
end;

  // Aktionsteil

//-------- run (public) ------------------------------------------------
procedure TWaggonAnwendung.run;
begin
  repeat
    if KnopfNeuerGueterwagen.angeklickt then begin
       naechsterGueterwagen := TGueterwagen.init(20,300,112);
       meineLokomotive.koppleAn(naechsterGueterwagen)
    end;
    if KnopfNeuerPersonenwagen.angeklickt then begin
       naechsterPersonenwagen := TPersonenwagen.init(20,300,92);
       meineLokomotive.koppleAn(naechsterPersonenwagen)
    end;
    if KnopfFahre.angeklickt then begin
       fahrzustand := True
    end;
    if KnopfStopp.angeklickt then begin
       fahrzustand := False
    end;
    if fahrzustand then meineLokomotive.bewegeUm(0.5)
  until KnopfEnde.angeklickt;
end;

  // Aufrumen

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonAnwendung.gibfrei;
begin
  inherited gibFrei;
  meineLokomotive.gibFrei;
  KnopfFahre.gibFrei;
  KnopfStopp.gibFrei;
  KnopfEnde.gibFrei;
  KnopfNeuerPersonenwagen.gibFrei;
  KnopfNeuerGueterwagen.gibFrei;
end;  

end.
