UNIT mTWaggonEreignisAnwendung;

interface

uses            mSum,mTAnwendung, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive, 
         mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TWaggonEreignisAnwendung = CLASS(TAnwendung)

     // Attribute
     private
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        KnopfEnde : TRechteckKnopf;
        KnopfFahre : TRechteckKnopf;
        KnopfNeuerGueterwagen : TRechteckKnopf;
        KnopfNeuerPersonenwagen : TRechteckKnopf;
        KnopfStopp : TRechteckKnopf;
        Fahrzustand : Wahrheitswert;
        zBeenden : Wahrheitswert;
        zMauswurdegeklickt : Wahrheitswert;

     //Objektbeziehungen:
        // hatTLokomotive : TLokomotive;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTRechteckKnopf1, // hatTRechteckKnopf2, // hatTRechteckKnopf3, // hatTRechteckKnopf4 : TRechteckKnopf;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteKeinEreignis;
        procedure bearbeiteMausClick(pMaus:Maus);
        procedure bearbeiteMausDoppelklick(pMaus:Maus);
        procedure bearbeiteMausUnten(pMaus : Maus);
        procedure bearbeiteTastaturDruck(pZeichen:Zeichen);
        procedure run; override;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonEreignisAnwendung.init;
begin
  inherited init;
  zMausWurdeGeklickt:= false;
  zBeenden          := falsch;
//  derBildschirm     := Bildschirm.init;
//  dieMaus           := Maus.init;
  meineLokomotive   := TLokomotive.init(500,250,90);
  KnopfFahre        := TRechteckKnopf.init(400,50,100,'Fahren',dieMaus);
  KnopfStopp        := TRechteckKnopf.init(400,75,100,'Anhalten',dieMaus);
  KnopfEnde         := TRechteckKnopf.init(400,125,100,'Ende',dieMaus);
  KnopfNeuerGueterwagen := TRechteckKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus) ;
  KnopfNeuerPersonenwagen := TRechteckKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus);
  Fahrzustand := false;
end;

  // Aktionsteil

//-------- bearbeiteKeinEreignis (public) ------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteKeinEreignis;
begin
    if fahrzustand then meineLokomotive.bewegeUm(0.5)
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausClick(pMaus:Maus);
begin
    if KnopfNeuerGueterwagen.innerhalb then begin
       naechsterGueterwagen := TGueterwagen.init(20,300,112);
       meineLokomotive.koppleAn(naechsterGueterwagen)
    end;
    if KnopfNeuerPersonenwagen.innerhalb then begin
       naechsterPersonenwagen := TPersonenwagen.init(20,300,92);
       meineLokomotive.koppleAn(naechsterPersonenwagen)
    end;
    if KnopfFahre.innerhalb then begin
       fahrzustand := True
    end;
    if KnopfStopp.innerhalb then begin
       fahrzustand := False
    end;
    if KnopfEnde.innerhalb then begin
       zBeenden := True
    end
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausDoppelklick(pMaus:Maus);
begin
  //Hier Code einfgen.
end;

//-------- bearbeiteMausUnten (public) ---------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausUnten(pMaus : Maus);
begin
   bearbeiteKeinEreignis
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TWaggonEreignisAnwendung.bearbeiteTastaturDruck(pZeichen:Zeichen);
begin
  //Hier Code einfgen.
end;

//-------- run (public) ------------------------------------------------
procedure TWaggonEreignisAnwendung.run;
begin
  repeat
     if dieMaus.istGedrueckt then
     begin
        if not zMausWurdeGeklickt then
        begin
           zMausWurdeGeklickt := True;
           bearbeiteMausClick(dieMaus)
        end
        else
        begin
           bearbeiteMausUnten(dieMaus)
        end
     end // von Maus gedrckt
     else
     begin //Maus ist nicht gedrckt
        zMausWurdeGeklickt := False;
        if dieMaus.doppelklick Then begin
           bearbeiteMausDoppelklick(dieMaus)
        end
        else begin
           if dieTastatur.wurdeGedrueckt then begin
              bearbeiteTastaturDruck(dieTastatur.zeichen)
           end
           else begin
              bearbeiteKeinEreignis  //bearbeite Leerlauf 
           end
        end
     end
  until zBeenden
end;

  // Aufrumen

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonEreignisAnwendung.gibfrei;
begin
  meineLokomotive.gibFrei;
  KnopfFahre.gibFrei;
  KnopfStopp.gibFrei;
  KnopfEnde.gibFrei;
  KnopfNeuerPersonenwagen.gibFrei;
  KnopfNeuerGueterwagen.gibFrei;
end;  

end.
