UNIT mTWaggonEreignisAnwendung;

interface

uses       mSum,mTEreignisAnwendung,
         mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive,
         mTEndeKnopf,mTFahreKnopf,mTGueterwagenknopf,mTPersonenwagenknopf,
         mtStoppKnopf;
// Uses-Klausel ggf. anpassen

type
   TWaggonEreignisAnwendung = CLASS(TEreignisAnwendung)

     // Attribute
     private
        KnopfEnde : TEndeKnopf;
        KnopfFahre : TFahreKnopf;
        KnopfNeuerGueterwagen : TGueterwagenKnopf;
        KnopfNeuerPersonenwagen : TPersonenwagenKnopf;
        KnopfStopp : TStoppKnopf;
     public
        naechsterGueterwagen : TGueterwagen;
        meineLokomotive : TLokomotive;
        naechsterPersonenwagen : TPersonenwagen;
        Fahrzustand : Wahrheitswert;

     //Objektbeziehungen:
        // hatTLokomotive : TLokomotive;
        // hatTPersonenwagen (0..n) of TPersonenwagen;
        // hatTGueterwagen (0..n) of TGueterwagen;
        // hatTEndeKnopf : TEndeKnopf;
        // hatTfahreKnopf : TfahreKnopf;
        // hatTGueterwagenKnopf : TGueterwagenKnopf;
        // hatTPersonenwagenKnopf : TPersonenwagenKnopf;
        // hatTStoppKnopf : TStoppKnopf;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf; override;
        procedure bearbeiteMausClick(pMaus:Maus); override;
        procedure bearbeiteMausDoppelklick(pMaus:Maus); override;
        procedure bearbeiteTastaturDruck(pZeichen:Zeichen); override;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggonEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggonEreignisAnwendung.init;
begin
  inherited init;
  meineLokomotive   := TLokomotive.init(500,250,90);
  KnopfEnde         := TEndeKnopf.init(400,125,100,'Ende',dieMaus,self);
  KnopfFahre        := TFahreKnopf.init(400,50,100,'Fahren',dieMaus,self);
  KnopfEnde.haengeKnopfAn (KnopfFahre);
  KnopfStopp        := TStoppKnopf.init(400,75,100,'Anhalten',dieMaus,self);
  KnopfEnde.haengeKnopfAn (KnopfStopp);
  KnopfNeuerGueterwagen := TGueterwagenKnopf.init(200,50,150,'Neuer Gterwagen',dieMaus,self) ;
  KnopfEnde.haengeKnopfAn (KnopfNeuerGueterwagen);
  KnopfNeuerPersonenwagen := TPersonenwagenKnopf.init(200,75,150,'Neuer Personenwagen',dieMaus,self);
  KnopfEnde.haengeKnopfAn (KnopfNeuerPersonenwagen);
  Fahrzustand := false;
end;

  // Aktionsteil

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteLeerlauf;
begin
    if fahrzustand then meineLokomotive.bewegeUm(0.5)
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausClick(pMaus:Maus);
begin
  KnopfEnde.bearbeiteMausClick
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TWaggonEreignisAnwendung.bearbeiteMausDoppelklick(pMaus:Maus);
begin
  //Hier Code einfgen.
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TWaggonEreignisAnwendung.bearbeiteTastaturDruck(pZeichen:Zeichen);
begin
  //Hier Code einfgen.
end;

//-------- gibfrei (public) --------------------------------------------
destructor TWaggonEreignisAnwendung.gibfrei;
begin
  meineLokomotive.gibFrei;
  KnopfFahre.gibFrei;
  KnopfStopp.gibFrei;
  KnopfEnde.gibFrei;
  KnopfNeuerPersonenwagen.gibFrei;
  KnopfNeuerGueterwagen.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;  

end.
