UNIT mTEreignisKnopf;

interface

uses   mSuM, mTAnwendung;
// Uses-Klausel ggf. anpassen

type
   TEreignisKnopf = CLASS

     // Attribute
     private
        naechsterKnopf : TEreignisKnopf;
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         kenntAnwendung : TAnwendung;
         kannGedruecktWerden : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     //Objektbeziehungen:
        // kenntTEreignisKnopf () of TEreignisKnopf;
        // kenntTEreignisKnopf (0..1) of TEreignisKnopf;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TAnwendung);
        procedure bearbeiteLeerlauf; virtual;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual;
        procedure bearbeiteTastaturdruck; virtual;
        procedure haengeKnopfAn(pKnopf:TEreignisKnopf);
        function angeklickt : Wahrheitswert; virtual; abstract;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TAnwendung);
begin
  kannGedruecktWerden := True;
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  kenntAnwendung := pAnwendung;
  naechsterKnopf := nil;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisKnopf.bearbeiteLeerlauf;
begin
   //showmessage(zAufschrift+' bearbeitet Leerlauf');
   if naechsterKnopf <> nil then begin
      naechsterKnopf.bearbeiteLeerlauf
   end   
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisKnopf.bearbeiteMausClick;
begin
  //showmessage('Knopf '+zAufschrift+ ' bearbeitet Mausclick.');
  if naechsterKnopf <> nil then
     naechsterKnopf.bearbeiteMausClick;
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisKnopf.bearbeiteMausDoppelklick;
begin
end;

//-------- bearbeiteTastaturdruck (public) -----------------------------
procedure TEreignisKnopf.bearbeiteTastaturdruck;
begin
   //showmessage(zAufschrift+' bearbeitet Tastaturdruck');
end;

//-------- haengeKnopfAn (public) --------------------------------------
procedure TEreignisKnopf.haengeKnopfAn(pKnopf:TEreignisKnopf);
begin
  if naechsterKnopf = nil
     then naechsterKnopf := pKnopf
     else naechsterKnopf.haengeKnopfAn(pKnopf);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisKnopf.gibFrei;
begin
  zeichne;
  if naechsterKnopf <> nil then
     naechsterKnopf.gibFrei
end;

end.
