UNIT mTKnopf;

interface

uses       dialogs, mSuM, mTEreignisanwendung;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // Attribute
     private
        naechsterKnopf : TKnopf;
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         kenntAnwendung : TAnwendung;
         kannGedruecktWerden : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     //Objektbeziehungen:
        // kenntTKnopf () of TKnopf;
        // kenntTKnopf (0..1) of TKnopf;
        // kenntTAnwendung : TAnwendung;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TEreignisanwendung);
        procedure bearbeiteKeinEreignis; virtual; abstract;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual; abstract;
        procedure bearbeiteTastaturdruck; virtual; abstract;
        procedure haengeAn(pKnopf:TKnopf);
        function angeklickt : Wahrheitswert; virtual; abstract;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TEreignisanwendung);
begin
  kannGedruecktWerden := True;
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  kenntAnwendung := pAnwendung;
  naechsterKnopf := nil;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TKnopf.bearbeiteMausClick;
begin
  //showmessage('Knopf '+zAufschrift+ ' bearbeitet Mausclick.');
  if naechsterKnopf = nil then
     //showmessage('Knopf '+zAufschrift+ ' ist letzter Knopf.')
  else
  begin
     //showmessage ('Knopf '+zAufschrift+ ' gibt Klick weiter.');
     naechsterKnopf.bearbeiteMausClick;
     //showmessage('Folgeknpfe von ' + zAufschrift +' sind fertig');
  end   
end;

//-------- haengeAn (public) -------------------------------------------
procedure TKnopf.haengeAn(pKnopf:TKnopf);
begin
  if naechsterKnopf = nil
     then naechsterKnopf := pKnopf
     else naechsterKnopf.haengeAn(pKnopf);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  zeichne
end;

end.
