UNIT mTEreignisWaggon;

interface

uses       dialogs,mSum,mTEreignisbearbeiter,mTEreignisAnwendung;
// Uses-Klausel ggf. anpassen

type
   TEreignisWaggon = CLASS(TEreignisbearbeiter)

     // Attribute
     private
        naechsterWaggon : TEreignisWaggon;
     protected
         hatStift : BuntStift;
         zHPosition : Zahl;
         zLaenge : Zahl;
         zVPosition : Zahl;

     //Objektbeziehungen:
        // kenntTEreignisWaggon () of TEreignisWaggon;
        // kenntTEreignisWaggon (0..1) of TEreignisWaggon;

     // Methoden
     private
        function innerhalb : Wahrheitswert;
     public
        constructor init(pHPosition,pVPosition,pLaenge:Zahl;pAnwendung:TEreignisAnwendung);
        procedure bearbeiteMausClick; override;
        procedure bearbeiteMausDoppelklick; override;
        procedure bewegeUm(pDistanz:Zahl);
        procedure koppleAn(pWaggon:TEreignisWaggon);
        procedure zeichne; virtual; abstract;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisWaggon: Methodendefinition 
//+---------------------------------------------------------------------

//-------- innerhalb (private) -----------------------------------------
function TEreignisWaggon.innerhalb : Wahrheitswert;
begin
   result :=
       (kenntMaus.hPosition > zhPosition ) and
       (kenntMaus.hPosition < zhPosition + zLaenge) and
       (kenntMaus.vPosition < zvPosition + 15) and
       (kenntMaus.vPosition > zvPosition - 50)
end;

//-------- init (public) -----------------------------------------------
constructor TEreignisWaggon.init(pHPosition,pVPosition,pLaenge:Zahl;pAnwendung:TEreignisAnwendung);
begin
  inherited init(pAnwendung);
  zHPosition:=pHPosition;
  zVPosition:=pVPosition;
  zLaenge   :=pLaenge;  
  hatStift  :=BuntStift.init;
  hatStift.wechsle;
  naechsterWaggon := nil;
  self.zeichne;
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisWaggon.bearbeiteMausClick;
begin
  if innerhalb then begin
     zeichne;
     hatStift.setzeFarbe(rot);
     zeichne;
  end;
  inherited bearbeiteMausClick
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisWaggon.bearbeiteMausDoppelklick;
begin
  //showmessage('Wagggon Doppelklick ??');
  if innerhalb then begin
     //showmessage('Jau !! Doppelklick !!!!!!!!!');
     zeichne;
     hatStift.setzeFarbe(schwarz);
     zeichne;
  end;
  inherited bearbeiteMausDoppelklick
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TEreignisWaggon.bewegeUm(pDistanz:Zahl);
begin
  self.zeichne;
  zHPosition := zHPosition - pDistanz;
  self.zeichne;
  if naechsterWaggon <> nil then 
     naechsterWaggon.bewegeUm(pDistanz); 
end;

//-------- koppleAn (public) -------------------------------------------
procedure TEreignisWaggon.koppleAn(pWaggon:TEreignisWaggon);
begin
  if naechsterWaggon = nil then begin
     naechsterWaggon := pWaggon;
     naechsterWaggon.zeichne; //Lschen an der alten Position
     naechsterWaggon.zHPosition := self.zHPosition+self.zLaenge;
     naechsterWaggon.zVPosition := self.zVPosition;
     naechsterWaggon.zeichne;
  end
  else begin
     naechsterWaggon.koppleAn(pWaggon);
  end
end;

//-------- hPosition (public) ------------------------------------------
function TEreignisWaggon.hPosition : Zahl;
begin
  result := zHPosition
end;

//-------- vPosition (public) ------------------------------------------
function TEreignisWaggon.vPosition : Zahl;
begin
  result := zVPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisWaggon.gibFrei;
begin
  self.zeichne;
  hatStift.gibFrei;
  inherited gibFrei    
end;

end.
