UNIT mEreignisanwendung;

interface

uses  mSuM, mAnwendung;
// Uses-Klausel ggf. anpassen

type
   Ereignisanwendung = CLASS(Anwendung)

     // Attribute
     public
        zbeendet : Wahrheitswert;
        zMausGedrueckt : Wahrheitswert;
        zAlteHPosition : Zahl;
        zAlteVPosition : Zahl;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteDoppelklick(ph,pv:Zahl); virtual;
        procedure bearbeiteLeerlauf; virtual;
        procedure bearbeiteMausBewegt(ph,pv:Zahl); virtual;
        procedure bearbeiteMausdruck(ph,pv:Zahl); virtual;
        procedure bearbeiteMausLos(ph,pv:Zahl); virtual;
        procedure bearbeiteTaste(pZeichen:Zeichen); virtual;
        procedure beenden;
        procedure fuehreAus; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         Ereignisanwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor Ereignisanwendung.init;
begin
  inherited init;
  zbeendet:=false;
  zMausGedrueckt:=false;
  zAlteHPosition:=hatMaus.HPosition;
  zAlteVPosition:=hatMaus.VPosition;
end;

//-------- bearbeiteDoppelklick (public) -------------------------------
procedure Ereignisanwendung.bearbeiteDoppelklick(ph,pv:Zahl);
begin
{abstrakt}
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure Ereignisanwendung.bearbeiteLeerlauf;
begin
{abstrakt}
end;

//-------- bearbeiteMausBewegt (public) --------------------------------
procedure Ereignisanwendung.bearbeiteMausBewegt(ph,pv:Zahl);
begin
{abstrakt}
end;

//-------- bearbeiteMausdruck (public) ---------------------------------
procedure Ereignisanwendung.bearbeiteMausdruck(ph,pv:Zahl);
begin
{abstrakt}
end;

//-------- bearbeiteMausLos (public) -----------------------------------
procedure Ereignisanwendung.bearbeiteMausLos(ph,pv:Zahl);
begin
{abstrakt}
end;

//-------- bearbeiteTaste (public) -------------------------------------
procedure Ereignisanwendung.bearbeiteTaste(pZeichen:Zeichen);
begin
{abstrakt}
end;

//-------- beenden (public) --------------------------------------------
procedure Ereignisanwendung.beenden;
begin
  zbeendet:=true;
end;

//-------- fuehreAus (public) ------------------------------------------
procedure Ereignisanwendung.fuehreAus;
begin
  repeat
    if hatMaus.IstGedrueckt then
    begin
      self.BearbeiteMausDruck(hatMaus.hPosition, hatMaus.vPosition);
      zMausGedrueckt:=true;
    end
    else if zMausGedrueckt then
         begin
           self.BearbeiteMausLos(hatMaus.hPosition, hatMaus.vPosition);
           zMausGedrueckt:=false;
         end;

    if hatMaus.doppelklick then
      self.BearbeiteDoppelklick(hatMaus.hPosition, hatMaus.vPosition);

    if hatTastatur.wurdeGedrueckt then
       begin
	  bearbeiteTaste(hatTastatur.Zeichen);
	  hatTastatur.weiter
       end;

    if (hatMaus.hPosition<>zAlteHPosition) or
    (hatMaus.vPosition<>zAlteVPosition)
    then
    begin
     zAlteHPosition:=hatMaus.HPosition;
     zAlteVPosition:=hatMaus.VPosition;
     self.bearbeiteMausBewegt(zAlteHPosition,zAlteVPosition);
    end;

    self.bearbeiteLeerlauf;
  until zbeendet;
end;

end.
