UNIT mEreignisverteiler;

interface

uses  mSuM;
// Uses-Klausel ggf. anpassen

type
   Ereignisverteiler = CLASS

     // Attribute

     //Objektbeziehungen:
        // kenntEreignisBearbeiter (0..n) of EreignisBearbeiter;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteDoppelKlick(pHPosition,pVPosition:Zahl);
        procedure bearbeiteLeerlauf;
        procedure bearbeiteMausBewegt(pHPositioninH,pHPositioninV:Zahl);
        procedure bearbeiteMausDruck(pHPosition,pVPosition:Zahl);
        procedure bearbeiteMausLos(pHPosition,pVPosition:Zahl);
        procedure bearbeiteTaste(pZeichen:Zeichen);
        procedure meldeAn(pNeu:EreignisBearbeiter);
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         Ereignisverteiler: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor Ereignisverteiler.init;
   begin
     inherited init;
   end;

//-------- bearbeiteDoppelKlick (public) -------------------------------
procedure Ereignisverteiler.bearbeiteDoppelKlick(pHPosition,pVPosition:Zahl);
  var
     aktuell:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.bearbeiteDoppelKlick(pHPosition,pVPosition);
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.bearbeiteDoppelKlick(pHPosition,pVPosition);
      end;
   end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure Ereignisverteiler.bearbeiteLeerlauf;
  var
     kenntEreignisBearbeiter:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          kenntEreignisBearbeiter:=EreignisBearbeiter(self.zeigeElement);
          kenntEreignisBearbeiter.bearbeiteLeerlauf;
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        kenntEreignisBearbeiter:=EreignisBearbeiter(self.zeigeElement);
        kenntEreignisBearbeiter.bearbeiteLeerlauf;
      end;
   end;

{Ereignisverteiler ************************************************************}

//-------- bearbeiteMausBewegt (public) --------------------------------
procedure Ereignisverteiler.bearbeiteMausBewegt(pHPositioninH,pHPositioninV:Zahl);
   var
     aktuell:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.bearbeiteMausBewegt(pHPositioninH,pHPositioninV);
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.bearbeiteMausBewegt(pHPositioninH,pHPositioninV);
      end;
   end;

//-------- bearbeiteMausDruck (public) ---------------------------------
procedure Ereignisverteiler.bearbeiteMausDruck(pHPosition,pVPosition:Zahl);
   var
     aktuell:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.bearbeiteMausDruck(pHPosition,pVPosition);
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.bearbeiteMausDruck(pHPosition,pVPosition);
      end;
   end;

//-------- bearbeiteMausLos (public) -----------------------------------
procedure Ereignisverteiler.bearbeiteMausLos(pHPosition,pVPosition:Zahl);
   var
     aktuell:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.bearbeiteMausLos(pHPosition,pVPosition);
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.bearbeiteMausLos(pHPosition,pVPosition);
      end;
   end;

//-------- bearbeiteTaste (public) -------------------------------------
procedure Ereignisverteiler.bearbeiteTaste(pZeichen:Zeichen);
   var
     aktuell:ereignisBearbeiter;
   begin
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.bearbeiteTaste(pZeichen);
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.bearbeiteTaste(pZeichen);
      end;
   end;

//-------- meldeAn (public) --------------------------------------------
procedure Ereignisverteiler.meldeAn(pNeu:EreignisBearbeiter);
   begin
     self.einfuegen(pNeu);
   end;

//-------- gibFrei (public) --------------------------------------------
destructor Ereignisverteiler.gibFrei;
   var
     aktuell: EreignisBearbeiter;
   begin
      // zunchst die gespeicherten EreignisBearbeiter freigeben
      if not self.leer then begin
        self.zumAnfang;
        while not self.letzter do begin
          aktuell:=EreignisBearbeiter(self.zeigeElement);
          aktuell.gibFrei;
          self.zumNaechsten;
        end;
        //bearbeite letztesListenElement
        aktuell:=EreignisBearbeiter(self.zeigeElement);
        aktuell.gibFrei;
      end;
      inherited gibFrei // die Listenelemente selbst freigeben
   end;

end.
